<html>
  <head>
    <meta charset="UTF-8">
    <title>Fibonacci</title>
  </head>
  <body>
    <script>
        function execute(f, p) {
          startTime = new Date();
          result = f(document.getElementById('n').value);
          endTime = new Date();
          duration = (endTime - startTime)
          document.getElementById(p + "_fibo").innerText = result;
          document.getElementById(p + "_time").innerText = "Calculated in " + duration.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,') + " ms";
        }
    </script>
    <!-- =========================================================== -->
    <script>
      let js_fibo = function(n) {
        if (n <= 1) return 1;
        return js_fibo(n - 1) + js_fibo(n - 2);
      }
    </script>
    <!-- =========================================================== -->
    <script>
      let cpp_fibo = function(n) {
        return -n;
      }

      function loadWasm(fileName) {
        var imports = {
          // env: {},
          // abortStackOverflow: {},
        };
        return fetch(fileName, { credentials: 'same-origin' })
          .then(response => response.arrayBuffer())
          .then(bits => WebAssembly.compile(bits))
          .then(module => WebAssembly.instantiate(module, imports));
      };

      loadWasm('fibo_cpp_js.wasm')
        .then(instance => {
          cpp_fibo = instance.exports.__Z4fiboj;
        });
    </script>
    <!-- =========================================================== -->
    <script>
      let rust_fibo = function(n) {
        return -n;
      }

      function loadWasm(fileName) {
        var imports = {
          wasi_unstable: {},
          env: {},
          abortStackOverflow: {}
        };
        return fetch(fileName, { credentials: 'same-origin' })
          .then(response => response.arrayBuffer())
          .then(bits => WebAssembly.compile(bits))
          .then(module => WebAssembly.instantiate(module, imports));
      };
      loadWasm('fibo_rust_js.wasm')
        .then(instance => {
          rust_fibo = instance.exports.fibo;
        });
    </script>

    N : <input id="n" value="43"/>
    <br/>
    <br/>
    <button onclick="execute(js_fibo, 'js')">Fibo JavaScript</button>
    <div id="js_fibo"></div>
    <div id="js_time"></div>
    <br/>
    <button onclick="execute(cpp_fibo, 'cpp')">Fibo WebAssembly from C++</button>
    <div id="cpp_fibo"></div>
    <div id="cpp_time"></div>
    <br/>
    <button onclick="execute(rust_fibo, 'rust')">Fibo WebAssembly from Rust</button>
    <div id="rust_fibo"></div>
    <div id="rust_time"></div>
  </body>
</html>
